gtkmm: Gtk::Root Class Reference

gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Root Class Reference

Interface for root widgets. More...

`#include <gtkmm/root.h>`

Inheritance diagram for Gtk::Root:
[legend]

## Public Member Functions
| Root (Root && src) noexcept
Root & | operator= (Root && src) noexcept
| ~Root () noexcept override
GtkRoot * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkRoot * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Returns the display that this `Gtk::Root` is on. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Returns the display that this `Gtk::Root` is on. More...
void | set_focus (Widget & focus)
| If focus is not the current focus widget, and is focusable, sets it as the focus widget for the root. More...
void | unset_focus ()
| Unsets the focus widget for the root. More...
Widget * | get_focus ()
| Retrieves the current focused widget within the root. More...
const Widget * | get_focus () const
| Retrieves the current focused widget within the root. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Root ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::Root > | wrap (GtkRoot * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Interface for root widgets.

Gtk::Root is the interface implemented by all widgets that can act as a toplevel widget to a hierarchy of widgets. The root widget takes care of providing the connection to the windowing system and manages layout, drawing and event delivery for its widget hierarchy.

The obvious example of a Gtk::Root is Gtk::Window.

See also
  Gtk::Window

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ Root() [1/2]

Gtk::Root::Root | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Root() [2/2]

Gtk::Root::Root | ( | Root && | src | ) |
| noexcept

## ◆ ~Root()

Gtk::Root::~Root | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::Root::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_display() [1/2]

Glib::RefPtr<Gdk::Display> Gtk::Root::get_display | ( |  | ) |

Returns the display that this `Gtk::Root` is on.

Returns
  The display of root.

## ◆ get_display() [2/2]

Glib::RefPtr<const Gdk::Display> Gtk::Root::get_display | ( |  | ) | const

Returns the display that this `Gtk::Root` is on.

Returns
  The display of root.

## ◆ get_focus() [1/2]

Widget* Gtk::Root::get_focus | ( |  | ) |

Retrieves the current focused widget within the root.

Note that this is the widget that would have the focus if the root is active; if the root is not focused then `gtk_widget_has_focus (widget)` will be `false` for the widget.

Returns
  The currently focused widget.

## ◆ get_focus() [2/2]

const Widget* Gtk::Root::get_focus | ( |  | ) | const

Retrieves the current focused widget within the root.

Note that this is the widget that would have the focus if the root is active; if the root is not focused then `gtk_widget_has_focus (widget)` will be `false` for the widget.

Returns
  The currently focused widget.

## ◆ get_type()

static GType Gtk::Root::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkRoot* Gtk::Root::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkRoot* Gtk::Root::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

Root& Gtk::Root::operator= | ( | Root && | src | ) |
| noexcept

## ◆ set_focus()

void Gtk::Root::set_focus | ( | Widget & | focus | ) |

If focus is not the current focus widget, and is focusable, sets it as the focus widget for the root.

To set the focus to a particular widget in the root, it is usually more convenient to use Gtk::Widget::grab_focus() instead of this function.

Parameters

  focus | Widget to be the new focus widget.

## ◆ unset_focus()

void Gtk::Root::unset_focus | ( |  | ) |

Unsets the focus widget for the root.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Root > wrap | ( | GtkRoot * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.